VERSION 5.00
Begin VB.Form f_Game 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "Form1"
   ClientHeight    =   7395
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9360
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   493
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   624
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "f_Game"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  
Private Sub Form_Load()
    
    '===================
    'Game version number
    '===================
    GameVersion = "v0.18b"
    
    '=====================
    'General Error Handler
    '=====================
    On Error Resume Next

    '=============
    'Start loading
    '=============
    Set TV = New TrueVision8
    Set Scene = New Scene8
    Set Land = New Landscape8
    Set Scr = New Screen8
    Set Camera = New Camera8
    Set TexFactory = New TextureFactory8
    Set Tex8 = New Texture8
    Set Effect = New GraphicEffect8
    Set Particle = New ParticleSystem8
    Set Light = New LightEngine8
    
    '==========
    'Set actors
    '==========
    Dim k As Integer
    For k = 0 To 99
        Set Mammoth(k) = New Actor8
        Set Mosquito(k) = New Actor8
    Next k
    
    '=============
    'Set buildings
    '=============
    Dim l As Integer
    For l = 0 To 99
        Set Silo(l) = New Actor8
    Next l
    
    '==============
    'Set user prefs
    '==============
    Set_User_Prefs
    
    '==================================
    'Set the game variables (materials)
    '==================================
    Set_Game
    
    '==================
    'Load tv in window
    '==================
    TV.Init3DWindowedMode f_Game.hWnd
    f_Game.Show
    
    '=====================
    'Load auto full screen
    '=====================
    'TV.Init3DFullscreen 800, 600, 16
    
    '================
    'Load full screen
    '================
    'If TV.ShowDriverDialog = False Then End
    'V.Initialize
   
    '==================================
    'set screensize (for move cam move)
    '==================================
    Dim wi As Long, he As Long, fo As Long
    TV.GetVideoMode wi, he, fo
    ScrWidthTmp = wi
    ScrHeightTmp = he
    ScrWidth = Int(ScrWidthTmp)
    ScrHeight = Int(ScrHeightTmp)
    
    '============
    'set tv input
    '============
    Set Inp = New InputEngine8
    
    '========
    'Show fps
    '========
    'TV.DisplayFPS = False
    TV.DisplayFPS = True
    
    '====================================
    'Nothing to say to the player, yet...
    '====================================
    Dim m As Integer
    For m = 0 To 3
        Info2Player(m) = ""
    Next m
    
    '================
    'Show game's menu
    '================
    MenuVisible = True
    
    '==========================
    'Defines the data directory
    '==========================
    TV.SetSearchDirectory App.Path
  
    '================================
    'Set keyboard keypressed as false
    '================================
    Set_Keyboard

    '====================
    'Create font for menu
    '====================
    Scr.CreateUserFont "screeninfo", "FixedSys", 10, False, False, False
   
    '==============
    'Set the ground
    '==============
    Set_Ground
    
    '===============
    'Set atmospheric
    '===============
    Set_Atmos
    
    '=============
    'Set the mouse
    '=============
    Set_Mouse
    
    '=========
    'Set tanks
    '=========
    Set_Tanks
    
    '=============
    'set buildings
    '=============
    Set_Buildings
    
    '===========
    'set the sky
    '===========
    Set_Sky
    
    '=========================
    'Set the camera properties
    '=========================
    Set_Camera
    
    '==============
    'Start the game
    '==============
    GameRunning = True
    Info2Player(0) = "Game Started!"
    Effect.FadeIn 500
    
    '===================
    'Start the game loop
    '===================
    Game_Loop
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    '====================
    'Shut down the engine
    '====================
    Set TV = Nothing
    End
End Sub

Private Sub Set_Keyboard()
    
    '============================
    'Global keys lowered to false
    '============================
    l_F1 = False
    l_F2 = False
    l_F3 = False
    l_F4 = False
    l_F5 = False
    l_F6 = False
    l_F7 = False
    l_F8 = False
    l_F9 = False
    l_F10 = False
    l_F11 = False
    l_F12 = False
    l_1 = False
    l_2 = False
    l_3 = False
    l_4 = False
    l_5 = False
    l_6 = False
    l_7 = False
    l_8 = False
    l_9 = False
    l_0 = False
    l_A = False
    l_B = False
    l_C = False
    l_D = False
    l_E = False
    l_F = False
    l_G = False
    l_H = False
    l_I = False
    l_J = False
    l_K = False
    l_L = False
    l_M = False
    l_N = False
    l_O = False
    l_P = False
    l_Q = False
    l_R = False
    l_S = False
    l_T = False
    l_U = False
    l_V = False
    l_W = False
    l_X = False
    l_Y = Falseq
    l_Z = False
    l_SPACE = False
    l_ENTER = False
    l_LCTRL = False
    l_RCTRL = False
    l_ESC = False
    l_INSERT = False
    l_SHIFT = False
    l_b1 = False
    l_b2 = False

End Sub

Private Sub Set_User_Prefs()
    
    '================
    'Set camera speed
    '================
    CamSpdKeyboard = 3
    CamSpdMouse = 1
    
    '===============
    'Set menu/panels
    '===============
    MenuTransparency = 0.5
    
    '===============
    'set team chosen
    '===============
    TeamChosen = 1
    
End Sub

Private Sub Set_Game()

    '=================================
    'How many material patches we have
    '=================================
    QtyMaterials = 0

End Sub

Private Sub Set_Ground()
    
    '==================
    'Landscape creation
    '==================
    'Land.CreateDynTextures 256, 256, True
    Land.SetFactorY 0.5
    Land.GenerateHugeTerrain "..\maps\height1.bmp", TV_PRECISION_LOW, 8, 8, 0, 0, False
 
    '============
    'Load texture
    '============
    Scene.LoadTexture "..\images\ground.jpg", , , "TerrainTexture"
    Land.SetTexture GetTex("TerrainTexture")
    Land.SetTextureScale 2, 2
    
    '============
    'Create rocks
    '============
    Scene.LoadTexture "..\models\materials\materials.bmp", , , "MaterialsTex"
    Dim x As Single, z As Single, y As Single
    Dim i As Integer
    For i = 0 To QtyMaterials
        x = Rnd * 2048
        z = Rnd * 2048
        y = Land.GetHeight(x, z)
        
        'Create materials
        Set Materials(i) = Scene.CreateMeshBuilder
        Materials(i).Load3DsMesh "..\models\materials\materials.3ds"
        Materials(i).ScaleMesh 1, 1, 1
        
        'Set collision sphere
        'Materials(i).ComputeSphere
        
        'Set the texture
        Materials(i).SetTexture GetTex("MaterialsTex")
        
        'Enable the chroma effect
        'Materials(i).EnableSphereMapping True, 1
        
        'Set the materials vertex type for lightning
        'Materials(i).SetVertexType TV_NORMAL_VERTEX
        
        'Set the position
        Materials(i).SetPosition x, y, z
    Next i
    
    '===========================================
    'Enable mip mapping for more speed. Optional
    '===========================================
    Scene.EnableMipMapping
  
End Sub

Private Sub Set_Atmos()
    
    '======================
    'Set the Daytime clock!
    '======================
    DayTime = 2400
    Ticker = 0
    
    '===========
    'Set the sun
    '===========
    'Sun = Light.CreatePointLight(Vector(0, 100, 0), 500, 1, 1, 1, 1)
    'Light.EnableLight Sun, True
    'Light.SetLightAttenuation Sun, 1, 1, 1
    
    '=============
    'Load the snow
    '=============
    'TexFactory.LoadTexture "..\images\flocon.bmp", "Snow", , , TV_COLORKEY_RED
    'Land.InitRain 10, GetTex("Snow")
    
End Sub

Private Sub Set_Mouse()
    
    '=======================
    'Load the default cursor
    '=======================
    Select Case TeamChosen
        Case 0
            Scene.LoadCursor "..\images\cursors\r_default.bmp", TV_COLORKEY_BLACK, 32, 32
        Case 1
            Scene.LoadCursor "..\images\cursors\b_default.bmp", TV_COLORKEY_BLACK, 32, 32
        Case 2
            Scene.LoadCursor "..\images\cursors\g_default.bmp", TV_COLORKEY_BLACK, 32, 32
        Case 3
            Scene.LoadCursor "..\images\cursors\y_default.bmp", TV_COLORKEY_BLACK, 32, 32
    End Select
    
    '==============
    'Mouse movement
    '==============
    CamStepMouseMove = 1.5
    CamMouseSmooth = 0

    '=========================
    'set mouse cursor position
    '=========================
    Inp.SetMousePosition Int(ScrWidth / 2), Int(ScrHeight / 2)

End Sub

Private Sub Set_Tanks()
    
    '=======================
    'How many tanks we have?
    '=======================
    QtyMammoth = 0
    QtyMosquito = 0
    
    '=======================================
    'Create some Mammoths and some mosquitos
    '=======================================
    Create_Mammoth
    Create_Mammoth
    Create_Mammoth
    Create_Mammoth
    Create_Mammoth
    Create_Mosquito
    Create_Mosquito
    
    '=======================
    'Select tanks by default
    '=======================
    TankTypeSelected = 0
    MammothSelected = 0
    MosquitoSelected = 0
    
End Sub

Private Sub Set_Buildings()
    
    '===========================
    'How many buildings we have?
    '===========================
    QtySilo = 0
    
    '=================================
    'We don't have to place a silo yet
    '=================================
    PlaceTheSilo = False
        
End Sub

Private Sub Set_Camera()
    
    '==============
    'Set cam height
    '==============
    CamMaxHeight = 150
    
    '==============
    'Set cam smooth
    '==============
    CamSmooth = 0
    CamSmoothKey = 0.025 * CamSpdKeyboard
    CamSmoothMouse = 0.025 * CamSpdMouse
    CamSmoothX = 0
    CamSmoothY = 0
    CamSmoothZ = 0
    CamMoveNegative = False
    
    '===================
    'Set camera position
    '===================
    CamPosX = 450
    CamPosY = 110
    CamPosZ = 500
    
    '===============
    'Set cam look at
    '===============
    CamLookX = 460
    CamLookY = 100
    CamLookZ = 500
    
    '=======
    'Set cam
    '=======
    'Scene.SetViewFrustum 90, 800
    Camera.SetCameraPosition CamPosX, CamPosY, CamPosZ
    Camera.SetCameraLookAt CamLookX, CamLookY, CamLookZ
    
    '==================
    'Reset save cam pos
    '==================
    For i = 0 To 3
        CamSavePosX(i) = CamPosX
        CamSavePosY(i) = CamPosY
        CamSavePosZ(i) = CamPosZ
        CamSaveLookX(i) = CamLookX
        CamSaveLookY(i) = CamLookY
        CamSaveLookZ(i) = CamLookZ
    Next i
    
End Sub

Private Sub Set_Sky()
    
    '======================================
    'Set the general settings for the scene
    '======================================
    Scene.SetSceneBackGround 0.45, 0.37, 0.3
 
    '============
    'Load the sky
    '============
    'TexFactory.LoadTexture "..\images\down.jpg", "Up"
    'TexFactory.LoadTexture "..\images\left.jpg", "Left"
    'TexFactory.LoadTexture "..\images\up.jpg", "Down"
    'TexFactory.LoadTexture "..\images\right.jpg", "Right"
    'TexFactory.LoadTexture "..\images\front.jpg", "Front"
    'TexFactory.LoadTexture "..\images\back.jpg", "Back"
    
    '==========================
    'Apply the sky in the scene
    '==========================
    'Scene.SetSkyTexture GetTex("Front"), GetTex("Back"), GetTex("Left"), GetTex("Right"), GetTex("up"), GetTex("down")

End Sub

Private Sub Game_Loop()
    
    '==================
    'The main game loop
    '==================
    Do
    
        'Check keypress
        Check_KeyPress
        
        'Check mouse
        Check_Mouse
        
        'Update tanks
        Update_Tanks
        
        'Update Cam move
        Update_Cam_Movement
        
        'Update Cam
        Update_Cam
        
        'Update DayTime
        Update_DayTime
        
        'Clear the screen. You must do this before rendering anything on the screen.
        TV.Clear
      
        'Render the sky
        'Scene.RenderSky
        
        'Render the mammoth tanks
        If QtyMammoth > 0 Then
            Dim i As Integer
            For i = 1 To QtyMammoth
                Mammoth(i).Render
            Next i
        End If
        
        'Render the Mosquito tanks
        If QtyMosquito > 0 Then
            Dim j As Integer
            For j = 1 To QtyMosquito
                Mosquito(j).Render
            Next j
        End If
        
        'Render the silo buildings
        If QtySilo > 0 Then
            Dim k As Integer
            For k = 1 To QtySilo
                Silo(k).Render
            Next k
        End If
        
        'Call the scene rendering (all meshes like rocks, etc)
        Scene.RenderAllMeshes

        'Render the land
        Land.Render
              
        'Call the menu rendering
        Draw_On_Screen
        
        'Render everything on the screen
        TV.RenderToScreen
      
    'Check the Escape Key that ends up the tutorial
    Loop Until GameRunning = False
    
    '=============
    'Quit the game
    '=============
    Unload f_Game

End Sub

Private Sub Check_KeyPress()
    
    '==================
    'Escape key pressed
    '==================
    If Inp.IsKeyPressed(TV_KEY_ESCAPE) = True And l_ESC = False Then
        l_ESC = True 'we're pressing the key
        GameRunning = False
    End If
    If Inp.IsKeyPressed(TV_KEY_ESCAPE) = False Then
        l_ESC = False 'we're no longer pressing the key
    End If
    
    '=================
    'Shift key pressed
    '=================
    If Inp.IsKeyPressed(TV_KEY_LEFTSHIFT) = True And l_SHIFT = False Then
        l_SHIFT = True 'we're pressing the key
    End If
    If Inp.IsKeyPressed(TV_KEY_LEFTSHIFT) = False Then
        l_SHIFT = False 'we're no longer pressing the key
    End If
    
    '================
    'Move cam forward
    '================
    If Inp.IsKeyPressed(TV_KEY_UP) = True Then Cam_Move_Forward CamSpdKeyboard, CamSmoothKey
    
    '=================
    'Move cam backward
    '=================
    If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then Cam_Move_Backward CamSpdKeyboard, CamSmoothKey
    
    '=============
    'Move cam west
    '=============
    If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then Cam_Move_Left CamSpdKeyboard, CamSmoothKey
    
    '=============
    'Move cam east
    '=============
    If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then Cam_Move_Right CamSpdKeyboard, CamSmoothKey

    '===========
    'Move cam up
    '===========
    If Inp.IsKeyPressed(TV_KEY_PAGEUP) = True Then Cam_Move_Up (CamSpdKeyboard / 3), CamSmoothKey
    
    '=============
    'Move cam down
    '=============
    If Inp.IsKeyPressed(TV_KEY_PAGEDOWN) = True Then Cam_Move_Down (CamSpdKeyboard / 3), CamSmoothKey
        
    '======================
    'Menu visible/invisible
    '======================
    If Inp.IsKeyPressed(TV_KEY_SPACE) = True And l_SPACE = False Then
        l_SPACE = True 'we're pressing the key
        If MenuVisible = False Then
            MenuVisible = True
        Else
            MenuVisible = False
        End If
    End If
    If Inp.IsKeyPressed(TV_KEY_SPACE) = False Then
        l_SPACE = False 'we're no longer pressing the key
    End If
    
    '=================
    'Save cam position
    '=================
    If Inp.IsKeyPressed(TV_KEY_LEFTCONTROL) = True And l_LCTRL = False Then
        l_LCTRL = True 'we're pressing the key
    End If
    If Inp.IsKeyPressed(TV_KEY_LEFTCONTROL) = False Then
        l_LCTRL = False 'we're no longer pressing the key
    End If
        
        'Save Cam 0
        If Inp.IsKeyPressed(TV_KEY_F1) = True And l_F1 = False And l_LCTRL = True Then
            l_F1 = True 'we're pressing the key
            Save_Cam_Pos 0
        End If
        If Inp.IsKeyPressed(TV_KEY_RCONTROL) = False Then
            l_F1 = False 'we're no longer pressing the key
        End If
        
        'Save Cam 1
        If Inp.IsKeyPressed(TV_KEY_F2) = True And l_F2 = False And l_LCTRL = True Then
            l_F2 = True 'we're pressing the key
            Save_Cam_Pos 1
        End If
        If Inp.IsKeyPressed(TV_KEY_RCONTROL) = False Then
            l_F2 = False 'we're no longer pressing the key
        End If
        
        'Save Cam 2
        If Inp.IsKeyPressed(TV_KEY_F3) = True And l_F3 = False And l_LCTRL = True Then
            l_F3 = True 'we're pressing the key
            Save_Cam_Pos 2
        End If
        If Inp.IsKeyPressed(TV_KEY_RCONTROL) = False Then
            l_F3 = False 'we're no longer pressing the key
        End If
        
        'Save Cam 3
        If Inp.IsKeyPressed(TV_KEY_F4) = True And l_F4 = False And l_LCTRL = True Then
            l_F4 = True 'we're pressing the key
            Save_Cam_Pos 3
        End If
        If Inp.IsKeyPressed(TV_KEY_RCONTROL) = False Then
            l_F4 = False 'we're no longer pressing the key
        End If
    
    '=================
    'Save cam position
    '=================
    If Inp.IsKeyPressed(TV_KEY_LEFTCONTROL) = True And l_LCTRL = False Then
        l_LCTRL = True 'we're pressing the key
    End If
    If Inp.IsKeyPressed(TV_KEY_LEFTCONTROL) = False Then
        l_LCTRL = False 'we're no longer pressing the key
    End If
        
        'Call Cam 0
        If Inp.IsKeyPressed(TV_KEY_F1) = True And l_F1 = False And l_LCTRL = False Then
            l_F1 = True 'we're pressing the key
            Call_Cam_Pos 0
        End If
        If Inp.IsKeyPressed(TV_KEY_RCONTROL) = False Then
            l_F1 = False 'we're no longer pressing the key
        End If
        
        'call Cam 1
        If Inp.IsKeyPressed(TV_KEY_F2) = True And l_F2 = False And l_LCTRL = False Then
            l_F2 = True 'we're pressing the key
            Call_Cam_Pos 1
        End If
        If Inp.IsKeyPressed(TV_KEY_RCONTROL) = False Then
            l_F2 = False 'we're no longer pressing the key
        End If
        
        'Call Cam 2
        If Inp.IsKeyPressed(TV_KEY_F3) = True And l_F3 = False And l_LCTRL = False Then
            l_F3 = True 'we're pressing the key
            Call_Cam_Pos 2
        End If
        If Inp.IsKeyPressed(TV_KEY_RCONTROL) = False Then
            l_F3 = False 'we're no longer pressing the key
        End If
        
        'Call Cam 3
        If Inp.IsKeyPressed(TV_KEY_F4) = True And l_F4 = False And l_LCTRL = False Then
            l_F4 = True 'we're pressing the key
            Call_Cam_Pos 3
        End If
        If Inp.IsKeyPressed(TV_KEY_RCONTROL) = False Then
            l_F4 = False 'we're no longer pressing the key
        End If
    
    '==============
    'Team = Team +1
    '==============
    If Inp.IsKeyPressed(TV_KEY_INSERT) = True And l_INSERT = False Then
        l_INSERT = True 'we're pressing the key
        TeamChosen = TeamChosen + 1
        If TeamChosen > 3 Then TeamChosen = 0
    End If
    If Inp.IsKeyPressed(TV_KEY_INSERT) = False Then
        l_INSERT = False 'we're no longer pressing the key
    End If
    
    '===================
    'Select Next Mammoth
    '===================
    If Inp.IsKeyPressed(TV_KEY_1) = True And l_1 = False Then
        l_1 = True 'we're pressing the key
        Select_Next_Mammoth
    End If
    If Inp.IsKeyPressed(TV_KEY_1) = False Then
        l_1 = False 'we're no longer pressing the key
    End If
            
    '====================
    'Select Next Mosquito
    '====================
    If Inp.IsKeyPressed(TV_KEY_2) = True And l_2 = False Then
        l_2 = True 'we're pressing the key
        Select_Next_Mosquito
    End If
    If Inp.IsKeyPressed(TV_KEY_2) = False Then
        l_2 = False 'we're no longer pressing the key
    End If
    
    'Render mode : TV_LINE
    If Inp.IsKeyPressed(TV_KEY_Q) = True Then Scene.SetRenderMode TV_LINE
   
    'Render mode : TV_POINT
    If Inp.IsKeyPressed(TV_KEY_W) = True Then Scene.SetRenderMode TV_POINT
    
    'Render mode : TV_SOLID
    If Inp.IsKeyPressed(TV_KEY_E) = True Then Scene.SetRenderMode TV_SOLID
    
    'break Cam heightmax (only for debug, feature will be disabled in game)
    If Inp.IsKeyPressed(TV_KEY_F5) = True Then CamMaxHeight = 5000
    
    '==========
    'Screenshot
    '==========
    If Inp.IsKeyPressed(TV_KEY_F12) = True Then
        TV.ScreenShot "..\screenshots\1" & ".bmp"
        Info2Player(0) = "Screenshot taken!"
    End If
    
    
    
End Sub

Private Sub Select_Next_Mammoth()
    
    '===================================
    'Do we have any mammoth on this map?
    '===================================
    If QtyMammoth = 0 Then
        Info2Player(0) = "You don't have any Mammoth tank!"
        Exit Sub
    End If
    
    '=====================
    'Kind of tank selected
    '=====================
    TankTypeSelected = 0
    
    '===========================
    'Number of the tank selected
    '===========================
    MammothSelected = MammothSelected + 1
    
    '=======================
    'If tankselect > qtytank
    '=======================
    If MammothSelected > QtyMammoth Then MammothSelected = 1
    
    '=========================
    'Move cam to tank position
    '=========================
    CamLookX = MammothPosX(MammothSelected)
    CamLookZ = MammothPosZ(MammothSelected)
    CamPosX = MammothPosX(MammothSelected) + 10
    CamPosZ = MammothPosZ(MammothSelected) + 10
    
    '===================
    'Stop moving the cam
    '===================
    Stop_Cam_Smooth
    
End Sub

Private Sub Select_Next_Mosquito()
    
    '===================================
    'Do we have any mammoth on this map?
    '===================================
    If QtyMosquito = 0 Then
        Info2Player(0) = "You don't have any Mosquito tank!"
        Exit Sub
    End If
    
    '=====================
    'Kind of tank selected
    '=====================
    TankTypeSelected = 1
    
    '===========================
    'Number of the tank selected
    '===========================
    MosquitoSelected = MosquitoSelected + 1
    
    '=======================
    'If tankselect > qtytank
    '=======================
    If MosquitoSelected > QtyMosquito Then MosquitoSelected = 1
    
    '=========================
    'Move cam to tank position
    '=========================
    CamLookX = MosquitoPosX(MosquitoSelected)
    CamLookZ = MosquitoPosZ(MosquitoSelected)
    CamPosX = MosquitoPosX(MosquitoSelected) + 10
    CamPosZ = MosquitoPosZ(MosquitoSelected) + 10
    
    '===================
    'Stop moving the cam
    '===================
    Stop_Cam_Smooth
    
End Sub

Private Sub Cam_Move_Forward(spd As Integer, smooth As Single)
    
    '========
    'Cam move
    '========
    CamSmooth = smooth
    CamSmoothX = spd
End Sub

Private Sub Cam_Move_Backward(spd As Integer, smooth As Single)
    
    '========
    'Cam move
    '========
    CamSmooth = smooth
    CamSmoothX = -spd
End Sub

Private Sub Cam_Move_Left(spd As Integer, smooth As Single)
    
    '========
    'Cam move
    '========
    CamSmooth = smooth
    CamSmoothZ = spd
End Sub

Private Sub Cam_Move_Right(spd As Integer, smooth As Single)
    
    '========
    'Cam move
    '========
    CamSmooth = smooth
    CamSmoothZ = -spd
End Sub

Private Sub Cam_Move_Up(spd As Integer, smooth As Single)
    
    '========
    'Cam move
    '========
    CamSmooth = smooth
    CamSmoothY = spd
End Sub

Private Sub Cam_Move_Down(spd As Integer, smooth As Single)
    
    '========
    'Cam move
    '========
    CamSmooth = smooth
    CamSmoothY = -spd
End Sub

Private Sub Check_Mouse()
    
    '==========================================
    'Get the mouse state with the absolute mode
    '==========================================
    Inp.GetAbsMouseState Mx, My, b1, b2
    
    '=================
    'Call movement cam
    '=================
    If My = 0 Then Cam_Move_Forward CamSpdMouse, CamSmoothMouse
    If My > ScrHeight - 1 Then Cam_Move_Backward CamSpdMouse, CamSmoothMouse
    If Mx = 0 Then Cam_Move_Left CamSpdMouse, CamSmoothMouse
    If Mx > ScrWidth - 1 Then Cam_Move_Right CamSpdMouse, CamSmoothMouse
    
    '==============================================
    'Reset mouse button if we are not pressing them
    '==============================================
    If b1 = 0 Then
        l_b1 = False 'we're no longer pressing the mouse button
    End If
    If b1 = 0 Then
        l_b1 = False 'we're no longer pressing the mouse button
    End If
    
    'Actors are have a little bit different method for mousepicking
    'You have to use a Macro function : ActorPicking.
    'ActorPicking Actor, BoneTouched
    'This function returns BoneTouched that indicates which bone has been picked.
    'Useful for FPS games (Shoot on head, or on body...)
    
    '============
    'Menu clicked
    '============
    'Next mammoth
    If b1 <> 0 And RollOnTexture = 1 And l_b1 = False Then
        l_b1 = True 'we're pressing the mouse button
        Select_Next_Mammoth
    End If
    
    'Next mosquito
    If b1 <> 0 And RollOnTexture = 2 And l_b1 = False Then
        l_b1 = True 'we're pressing the mouse button
        Select_Next_Mosquito
    End If
    
    'Create silo
    If b1 <> 0 And RollOnTexture = 3 And l_b1 = False Then
        l_b1 = True 'we're pressing the mouse button
        Init_Create_silo
    End If
    
    '================
    'Object placement
    '================
    If b1 <> 0 And RollOnTexture = 0 Then
        Set Pick = Scene.MousePicking(Mx, My, TV_COLLIDE_LANDSCAPE, TV_TESTTYPE_ACCURATETESTING)
        If Pick.IsCollision = True Then
    
            'If we have to place a silo
            If PlaceTheSilo = True Then
                
                'Create the silo
                Create_silo
                
                'Set silo position and angle
                SiloDestination(QtySilo) = Pick.GetImpactPoint
                SiloPosX(QtySilo) = SiloDestination(QtySilo).x
                SiloPosZ(QtySilo) = SiloDestination(QtySilo).z
                SiloPosY(QtySilo) = (Land.GetHeight(SiloPosX(QtySilo), SiloPosZ(QtySilo)))
            
                'set angle
                SiloAngle(QtySilo) = Int((360 * Rnd) + 1)
                Silo(QtySilo).SetRotation 0, SiloAngle(QtySilo), 0
            
                'PLace the silo
                Silo(QtySilo).SetPosition SiloPosX(QtySilo), SiloPosY(QtySilo), SiloPosZ(QtySilo)
            
                'silo placed
                PlaceTheSilo = False
                
                'inform the player
                Info2Player(0) = "Silo construction place selected!"
                
            End If
            
            'If we are trying to select a tank
            Dim i As Integer
            Dim p As D3DVECTOR
            p = Pick.GetImpactPoint
            
            'Check if it's a mammoth tank that was selected
            For i = 0 To QtyMammoth
                If p.x > MammothPosX(i) - 20 And p.x < MammothPosX(i) + 20 And p.z > MammothPosZ(i) - 20 And p.z < MammothPosZ(i) + 20 Then
                    MammothSelected = i
                    TankTypeSelected = 0
                    Info2Player(0) = "Mammoth tank selected!"
                End If
            Next i
        
            'Check if it's a Mosquito tank that was selected
            For i = 0 To QtyMosquito
                If p.x > MosquitoPosX(i) - 20 And p.x < MosquitoPosX(i) + 20 And p.z > MosquitoPosZ(i) - 20 And p.z < MosquitoPosZ(i) + 20 Then
                    MosquitoSelected = i
                    TankTypeSelected = 1
                    Info2Player(0) = "Mosquito tank selected!"
                End If
            Next i
        
        
        End If
    Exit Sub
    End If
    
    '===============
    'Object movement
    '===============
    If b2 <> 0 Then
        Set Pick = Scene.MousePicking(Mx, My, TV_COLLIDE_LANDSCAPE, TV_TESTTYPE_ACCURATETESTING)
        If Pick.IsCollision = True Then
            
            'What kind of thank has been selected?
            Select Case TankTypeSelected
                
                'mammoth
                Case 0
                    'Get the picked point with the ImpactPoint method
                    MammothDestination(MammothSelected) = Pick.GetImpactPoint
                    MammothDirection(MammothSelected) = VNormalize(VSubtract(MammothDestination(MammothSelected), Vector(MammothPosX(MammothSelected), MammothPosY(MammothSelected), MammothPosZ(MammothSelected))))
            
                    'Obtain the angle with trigo maths
                    If MammothDirection(MammothSelected).z > 0 Then
                        MammothTempAngle(MammothSelected) = Rad2Deg(Atn(MammothDirection(MammothSelected).x / MammothDirection(MammothSelected).z))
                    Else
                        MammothTempAngle(MammothSelected) = Rad2Deg(Atn(MammothDirection(MammothSelected).x / MammothDirection(MammothSelected).z)) + 180
                    End If
        
                    'Todo : add turning smoothing
                    MammothAngle(MammothSelected) = MammothTempAngle(MammothSelected)
                    Mammoth(MammothSelected).SetRotation 0, 90 + MammothAngle(MammothSelected), 0
                    MammothMove(MammothSelected) = True
        
                'mosquito
                Case 1
                    'Get the picked point with the ImpactPoint method
                    MosquitoDestination(MosquitoSelected) = Pick.GetImpactPoint
                    MosquitoDirection(MosquitoSelected) = VNormalize(VSubtract(MosquitoDestination(MosquitoSelected), Vector(MosquitoPosX(MosquitoSelected), MosquitoPosY(MosquitoSelected), MosquitoPosZ(MosquitoSelected))))
            
                    'Obtain the angle with trigo maths
                    If MosquitoDirection(MosquitoSelected).z > 0 Then
                        MosquitoTempAngle(MosquitoSelected) = Rad2Deg(Atn(MosquitoDirection(MosquitoSelected).x / MosquitoDirection(MosquitoSelected).z))
                    Else
                        MosquitoTempAngle(MosquitoSelected) = Rad2Deg(Atn(MosquitoDirection(MosquitoSelected).x / MosquitoDirection(MosquitoSelected).z)) + 180
                    End If
        
                    'Todo : add turning smoothing
                    MosquitoAngle(MosquitoSelected) = MosquitoTempAngle(MosquitoSelected)
                    Mosquito(MosquitoSelected).SetRotation 0, 90 + MosquitoAngle(MosquitoSelected), 0
                    MosquitoMove(MosquitoSelected) = True
                End Select
        End If
    Exit Sub
    End If

End Sub
    
Private Sub Update_Cam_Movement()
    
    '========
    'Cam move
    '========
    CamLookX = CamLookX + CamSmoothX
    CamPosX = CamLookX - 15
    CamLookZ = CamLookZ + CamSmoothZ
    CamPosZ = CamLookZ
    CamLookY = CamLookY + CamSmoothY
    CamPosY = CamLookY + 10

    '=================
    'Smooth the motion
    '=================
    If CamSmoothX > 0 Then
        CamSmoothX = CamSmoothX - CamSmooth
        If CamSmoothX < 0 Then CamSmoothX = 0
    ElseIf CamSmoothX < 0 Then
        CamSmoothX = CamSmoothX + CamSmooth
        If CamSmoothX > 0 Then CamSmoothX = 0
    End If
        
    If CamSmoothY > 0 Then
        CamSmoothY = CamSmoothY - CamSmooth
        If CamSmoothY < 0 Then CamSmoothY = 0
    ElseIf CamSmoothY < 0 Then
        CamSmoothY = CamSmoothY + CamSmooth
        If CamSmoothY > 0 Then CamSmoothY = 0
    End If
        
    If CamSmoothZ > 0 Then
        CamSmoothZ = CamSmoothZ - CamSmooth
        If CamSmoothZ < 0 Then CamSmoothZ = 0
    ElseIf CamSmoothZ < 0 Then
        CamSmoothZ = CamSmoothZ + CamSmooth
        If CamSmoothZ > 0 Then CamSmoothZ = 0
    End If
    
    '===================
    'get the land height
    '===================
    Dim res As Single
    res = Land.GetHeight(CamLookX, CamLookZ)
    
    '=====================================
    'Check that cam aint lower than ground
    '=====================================
    If CamLookY < res Then
        CamLookY = res
        CamPosY = CamLookY + 10
        CamSmoothY = 0
    End If
    
    '==================================
    'Check if it's first time rendering
    '==================================
    Static first As Boolean
    If first = False Then
        first = True
        CamLookY = res + 20
        CamPosY = CamLookY + 30
        CamSmoothY = 0
    End If
    
    '=========================================
    'Check that cam aint higher than maxheight
    '=========================================
    If CamLookY > CamMaxHeight Then
        CamLookY = CamMaxHeight
        CamPosY = CamMaxHeight + 10
        CamSmoothY = 0
    End If

End Sub

Private Sub Update_Cam()
    
    '================
    'Set cam position
    '================
    Camera.SetCameraLookAt CamLookX + CamSmoothX, CamLookY + CamSmoothY, CamLookZ + CamSmoothZ
    Camera.SetCameraPosition CamPosX + CamSmoothX, CamPosY + 10 + CamSmoothY, CamPosZ + CamSmoothZ
End Sub

Private Sub Update_DayTime()

    'Update DayTime
    If Ticker > 10000 Then
        
        'Its midday
        If DayTime = 1200 Then
            Info2Player(0) = "It's midday!" 'Inform player what time it is
        End If
        
        'Its midnight
        If DayTime = 2400 Then
            DayTime = 0
            Info2Player(0) = "It's midnight!" 'Inform player what time it is
        End If
        
        'Add some time
        DayTime = DayTime + 100
        Ticker = 0
    End If

    Ticker = Ticker + TV.TimeElapsed * 1 'To : Jeff, what is that *1 doing here?
End Sub

Private Sub Update_Tanks()
    
    '====================
    'Update Mammoth tanks
    '====================
    If QtyMammoth > 0 Then
        Dim i As Integer
        For i = 0 To QtyMammoth
        
            'Make the tank moving
            If MammothMove(i) = True Then
                Dim p As D3DVECTOR
                p = VAdd(Vector(MammothPosX(i), MammothPosY(i), MammothPosZ(i)), VScale(MammothDirection(i), MammothSpeed(i) * TV.TimeElapsed))
                MammothPosX(i) = p.x
                MammothPosZ(i) = p.z
                
                'Check if tank reached desti1nation
                If Int(MammothPosX(i) / 2) = Int(MammothDestination(i).x / 2) And Int(MammothPosZ(i) / 2) = Int(MammothDestination(i).z / 2) Then
                    MammothMove(i) = False
                End If
            End If
        
            'Get the ground slope under tank
            Dim o As D3DVECTOR
            o = VAdd(Vector(MammothPosX(i), MammothPosY(i), MammothPosZ(i)), VScale(MammothDirection(i), MammothSpeed(i) * TV.TimeElapsed))
            o.x = MammothPosX(i)
            o.z = MammothPosZ(i)
                
            'Set a temporary position variable
            Dim Posy1 As Single
            Dim Posy2 As Single
                
            'Set a temporary angle variable
            Dim ang2 As Single 'for pitch
            Dim ang3 As Single 'for roll
                
            'Get the land height with position for pitch
            Posy1 = Land.GetHeight(o.x + Cos(Deg2Rad(MammothTempAngle(i))) * 10, o.z + Sin(Deg2Rad(MammothTempAngle(i))) * 10)
            Posy2 = Land.GetHeight(o.x - Cos(Deg2Rad(MammothTempAngle(i))) * 10, o.z - Sin(Deg2Rad(MammothTempAngle(i))) * 10)
   
            'Get the pitch angle
            ang2 = Atn((Posy1 - Posy2) / 20)
                
            'Get the land height with position for rolling
            Posy1 = Land.GetHeight(o.x - Sin(Deg2Rad(MammothTempAngle(i))) * 4, o.z - Cos(Deg2Rad(MammothTempAngle(i))) * 4)
            Posy2 = Land.GetHeight(o.x + Sin(Deg2Rad(MammothTempAngle(i))) * 4, o.z + Cos(Deg2Rad(MammothTempAngle(i))) * 4)
                
            'Get the roll angle
            ang3 = Atn((Posy1 - Posy2) / 8)
                
            'Update tank rotation
            Mammoth(i).SetRotation Rad2Deg(ang2), 90 + MammothTempAngle(i), Rad2Deg(ang3)

            'Update tank position
            Mammoth(i).SetPosition MammothPosX(i), (Land.GetHeight(MammothPosX(i), MammothPosZ(i))) + 5, MammothPosZ(i)
        Next i
    End If
    
    '=====================
    'Update Mosquito tanks
    '=====================
    If QtyMosquito > 0 Then
        Dim j As Integer
        For j = 0 To QtyMosquito
    
            'Make the tank moving
            If MosquitoMove(j) = True Then
                Dim pp As D3DVECTOR
                pp = VAdd(Vector(MosquitoPosX(j), MosquitoPosY(j), MosquitoPosZ(j)), VScale(MosquitoDirection(j), MosquitoSpeed(j) * TV.TimeElapsed))
                MosquitoPosX(j) = pp.x
                MosquitoPosZ(j) = pp.z
                
                'Check if tank reached destination
                If Int(MosquitoPosX(j) / 2) = Int(MosquitoDestination(j).x / 2) And Int(MosquitoPosZ(j) / 2) = Int(MosquitoDestination(j).z / 2) Then
                    MosquitoMove(j) = False
                End If
            End If
        
            'Update tank angle
            
        
            'Update tank position
            Mosquito(j).SetPosition MosquitoPosX(j), (Land.GetHeight(MosquitoPosX(j), MosquitoPosZ(j))) + 5, MosquitoPosZ(j)
        Next j
    End If
    
End Sub

Private Sub Create_Mammoth()
    
    '=============================
    'One more mammoth on the field
    '=============================
    QtyMammoth = QtyMammoth + 1
    
    '=====================================
    'do we have more mammoth than allowed?
    '=====================================
    If QtyMammoth > 99 Then
        'add code here
        Info2Player(0) = "Maximum Mammoth tanks limit reached!"
        QtyMammoth = QtyMammoth - 1
        Beep
        Exit Sub
    End If
    
    '==========
    'Load model
    '==========
    Mammoth(QtyMammoth).Load "..\models\mammoth\mammoth.mdl"
    Mammoth(QtyMammoth).SetModelInBodyPart 0, TeamChosen
    
    '====================
    'Position the mammoth
    '====================
    Mammoth(QtyMammoth).SetScale 0.5, 0.5, 0.5
    Mammoth(QtyMammoth).SetSpeed ((1 * Rnd) + 0.1)
    Mammoth(QtyMammoth).SetAnimationName "idle"
    
    'Set mammoth position and angle
    MammothAngle(QtyMammoth) = Int((360 * Rnd) + 1)
    MammothPosX(QtyMammoth) = Int((1000 * Rnd) + 50)
    MammothPosZ(QtyMammoth) = Int((1000 * Rnd) + 50)
    MammothPosY(QtyMammoth) = (Land.GetHeight(MammothPosX(i), MammothPosZ(i))) + 10
    Mammoth(QtyMammoth).SetRotation 0, MammothAngle(QtyMammoth), 0
    
    'Set tank speed
    MammothSpeed(QtyMammoth) = 0.02
    
    '===========
    'Load shadow
    '===========
    'Mammoth(QtyMammoth).EnableShadowing True
    'TexFactory.LoadTexture "..\images\shadow.bmp", "shadow", , , TV_COLORKEY_BLACK
End Sub

Private Sub Create_Mosquito()
    
    '=============================
    'One more mosquito on the field
    '=============================
    QtyMosquito = QtyMosquito + 1
    
    '=====================================
    'do we have more mosquito than allowed?
    '=====================================
    If QtyMosquito > 99 Then
        'add code here
        Info2Player(0) = "Maximum mosquito tanks limit reached!"
        QtyMosquito = QtyMosquito - 1
        Beep
        Exit Sub
    End If
    
    '==========
    'Load model
    '==========
    Mosquito(QtyMosquito).Load "..\models\mosquito\mosquito.mdl"
    Mosquito(QtyMosquito).SetModelInBodyPart 0, TeamChosen
    
    '====================
    'Position the mosquito
    '====================
    Mosquito(QtyMosquito).SetScale 0.5, 0.5, 0.5
    Mosquito(QtyMosquito).SetSpeed ((1 * Rnd) + 0.1)
    Mosquito(QtyMosquito).SetAnimationName "idle"
    
    'Set mosquito position and angle
    MosquitoAngle(QtyMosquito) = Int((360 * Rnd) + 1)
    MosquitoPosX(QtyMosquito) = Int((1000 * Rnd) + 50)
    MosquitoPosZ(QtyMosquito) = Int((1000 * Rnd) + 50)
    MosquitoPosY(QtyMosquito) = (Land.GetHeight(MosquitoPosX(i), MosquitoPosZ(i))) + 10
    Mosquito(QtyMosquito).SetRotation 0, MosquitoAngle(QtyMosquito), 0
    
    'Set tank speed
    MosquitoSpeed(QtyMosquito) = 0.02
    
    '===========
    'Load shadow
    '===========
    'mosquito(Qtymosquito).EnableShadowing True
    'TexFactory.LoadTexture "..\images\shadow.bmp", "shadow", , , TV_COLORKEY_BLACK
    
End Sub

Private Sub Init_Create_silo()
    
    '==================================
    'do we have more silo than allowed?
    '==================================
    If QtySilo > 3 Then
        'add code here
        Info2Player(0) = "Maximum silos limit reached!"
        QtySilo = QtySilo
        Exit Sub
    End If

    '============================================================
    'announce the player that he must select a place to drop silo
    '============================================================
    Info2Player(0) = "Click an emplacement for the construction"
    
    '=======================
    'Set construction cursor
    '=======================
    Select Case TeamChosen
        Case 0
            Scene.LoadCursor "..\images\cursors\r_const.bmp", TV_COLORKEY_BLACK, 32, 32
        Case 1
            Scene.LoadCursor "..\images\cursors\b_const.bmp", TV_COLORKEY_BLACK, 32, 32
        Case 2
            Scene.LoadCursor "..\images\cursors\g_const.bmp", TV_COLORKEY_BLACK, 32, 32
        Case 3
            Scene.LoadCursor "..\images\cursors\y_const.bmp", TV_COLORKEY_BLACK, 32, 32
    End Select
    
    '========================
    'We have to place a silo!
    '========================
    PlaceTheSilo = True
    
End Sub

Private Sub Create_silo()
    
    '==========================
    'One more silo on the field
    '==========================
    QtySilo = QtySilo + 1
    
    '==========================
    'Set back to default cursor
    '==========================
    Select Case TeamChosen
        Case 0
            Scene.LoadCursor "..\images\cursors\r_default.bmp", TV_COLORKEY_BLACK, 32, 32
        Case 1
            Scene.LoadCursor "..\images\cursors\b_default.bmp", TV_COLORKEY_BLACK, 32, 32
        Case 2
            Scene.LoadCursor "..\images\cursors\g_default.bmp", TV_COLORKEY_BLACK, 32, 32
        Case 3
            Scene.LoadCursor "..\images\cursors\y_default.bmp", TV_COLORKEY_BLACK, 32, 32
    End Select
    
    '=========
    'Set color
    '=========
    Select Case TeamChosen
        Case 0
            'Silo(QtySilo).Load "..\models\silo\r_silo.mdl"
        Case 1
        
        Scene.LoadTexture "..\models\silo\b_silo.bmp", , , "b_silo"
        Set Silo(QtySilo) = Scene.CreateMeshBuilder
        Silo(QtySilo).Load3DsMesh "..\models\silo\silo.3ds"
        Silo(QtySilo).ScaleMesh 1, 1, 1
        'Set the texture
        Silo(QtySilo).SetTexture GetTex("b_silo")
        
        
        
        
        
            'Silo(QtySilo).Load "..\models\silo\b_silo.mdl"
        Case 2
            'Silo(QtySilo).Load "..\models\silo\g_silo.mdl"
        Case 3
            'Silo(QtySilo).Load "..\models\silo\y_silo.mdl"
    End Select
    
    '==============
    'Create silo
    '==============
    
    'Silo(QtySilo).SetScale 0.5, 0.5, 0.5
    'Silo(QtySilo).SetSpeed ((1 * Rnd) + 0.1)
    
    '===========
    'Load shadow
    '===========
    
End Sub

Private Sub Draw_On_Screen()
    
    '==============================
    'Load the textures for the menu
    '==============================
    Static firstmenudraw As Boolean
    If firstmenudraw = False Then
        firstmenudraw = True
        
        'Tanks icons
        TexFactory.LoadTexture "..\images\menu\mammoth1.jpg", "mammoth1", 200, 150, TV_COLORKEY_BLACK
        TexFactory.LoadTexture "..\images\menu\mammoth2.jpg", "mammoth2", 200, 150, TV_COLORKEY_BLACK
        TexFactory.LoadTexture "..\images\menu\mosquito1.jpg", "mosquito1", 400, 300, TV_COLORKEY_BLACK
        TexFactory.LoadTexture "..\images\menu\mosquito2.jpg", "mosquito2", 400, 300, TV_COLORKEY_BLACK
    
        'Building icons
        TexFactory.LoadTexture "..\images\menu\silo1.jpg", "silo1", 200, 150, TV_COLORKEY_BLACK
        TexFactory.LoadTexture "..\images\menu\silo2.jpg", "silo2", 200, 150, TV_COLORKEY_BLACK
    
    End If
    
    '==============
    'Info to player
    '==============
    
    'Draw the info boxes
    Select Case TeamChosen
        Case 0 'red
            Scr.DrawFilledBox 0, 0, 400, 52, RGBA(0.5, 0, 0, MenuTransparency), True
            Scr.DrawBox 0, 0, 400, 52, RGBA(1, 0, 0, MenuTransparency)
            Scr.DrawBox 1, 1, 399, 51, RGBA(1, 0, 0, MenuTransparency)
        Case 1 'blue note : blue is (0,0.3,1)... more clear
            Scr.DrawFilledBox 0, 0, 400, 52, RGBA(0, 0.2, 0.5, MenuTransparency), True
            Scr.DrawBox 0, 0, 400, 52, RGBA(0, 0.3, 1, MenuTransparency)
            Scr.DrawBox 1, 1, 399, 51, RGBA(0, 0.3, 1, MenuTransparency)
        Case 2 'green
            Scr.DrawFilledBox 0, 0, 400, 52, RGBA(0, 0.5, 0, MenuTransparency), True
            Scr.DrawBox 0, 0, 400, 52, RGBA(0, 1, 0, MenuTransparency)
            Scr.DrawBox 1, 1, 399, 51, RGBA(0, 1, 0, MenuTransparency)
        Case 3 'yellow
            Scr.DrawFilledBox 0, 0, 400, 52, RGBA(0.5, 0.5, 0, MenuTransparency), True
            Scr.DrawBox 0, 0, 400, 52, RGBA(1, 1, 0, MenuTransparency)
            Scr.DrawBox 1, 1, 399, 51, RGBA(1, 1, 0, MenuTransparency)
    End Select
    
    'Check if we have info to give to the player
    If Info2Player(0) <> Info2Player(1) Then
        Info2Player(3) = Info2Player(2)
        Info2Player(2) = Info2Player(1)
        Info2Player(1) = Info2Player(0)
    End If
        
    Select Case TeamChosen
        Case 0 'red
            Scr.DrawText ">" & Info2Player(1), 5, 3, RGBA(1, 1, 1, MenuTransparency), "screeninfo"
            Scr.DrawText " " & Info2Player(2), 5, 18, RGBA(1, 0, 0, MenuTransparency), "screeninfo"
            Scr.DrawText " " & Info2Player(3), 5, 33, RGBA(1, 0, 0, MenuTransparency), "screeninfo"
        Case 1 'blue note : blue is (0.4,0.4,1)... more clear
            Scr.DrawText ">" & Info2Player(1), 5, 3, RGBA(1, 1, 1, MenuTransparency), "screeninfo"
            Scr.DrawText " " & Info2Player(2), 5, 18, RGBA(0.4, 0.4, 1, MenuTransparency), "screeninfo"
            Scr.DrawText " " & Info2Player(3), 5, 33, RGBA(0.4, 0.4, 1, MenuTransparency), "screeninfo"
        Case 2 'green
            Scr.DrawText ">" & Info2Player(1), 5, 3, RGBA(1, 1, 1, MenuTransparency), "screeninfo"
            Scr.DrawText " " & Info2Player(2), 5, 18, RGBA(0, 1, 0, MenuTransparency), "screeninfo"
            Scr.DrawText " " & Info2Player(3), 5, 33, RGBA(0, 1, 0, MenuTransparency), "screeninfo"
        Case 3 'yellow
            Scr.DrawText ">" & Info2Player(1), 5, 3, RGBA(1, 1, 1, MenuTransparency), "screeninfo"
            Scr.DrawText " " & Info2Player(2), 5, 18, RGBA(1, 1, 0, MenuTransparency), "screeninfo"
            Scr.DrawText " " & Info2Player(3), 5, 33, RGBA(1, 1, 0, MenuTransparency), "screeninfo"
    End Select
    
    '========================================
    'Check if menu is enabled, if so, draw it
    '========================================
    If MenuVisible = False Then Exit Sub
    
    'Draw background menu
    Scr.DrawFilledBox ScrWidth - 152, 0, ScrWidth, ScrHeight, RGBA(0, 0, 0, 0), False
    
    'Draw menu border
    Select Case TeamChosen
        Case 0 'red
            Scr.DrawBox ScrWidth - 152, 0, ScrWidth - 151, ScrHeight, RGBA(1, 0, 0, 0)
        Case 1 'blue note : blue is (0,0.3,1)... more clear
            Scr.DrawBox ScrWidth - 152, 0, ScrWidth - 151, ScrHeight, RGBA(0, 0.3, 1, 0)
        Case 2 'green
            Scr.DrawBox ScrWidth - 152, 0, ScrWidth - 151, ScrHeight, RGBA(0, 1, 0, 0)
        Case 3 'yellow
            Scr.DrawBox ScrWidth - 152, 0, ScrWidth - 151, ScrHeight, RGBA(1, 1, 0, 0)
    End Select
    
    '================
    'Draw menu images
    '================
    
    'Write building text
    Select Case TeamChosen
        Case 0 'red
            Scr.DrawText "BUILDINGS", ScrWidth - 150, ScrHeight - 165, RGBA(1, 0, 0, 1), "screeninfo"
        Case 1 'blue note : blue is (0,0.3,1)... more clear
            Scr.DrawText "BUILDINGS", ScrWidth - 150, ScrHeight - 165, RGBA(0, 0.3, 1, 1), "screeninfo"
        Case 2 'green
            Scr.DrawText "BUILDINGS", ScrWidth - 150, ScrHeight - 165, RGBA(0, 1, 0, 1), "screeninfo"
        Case 3 'yellow
            Scr.DrawText "BUILDINGS", ScrWidth - 150, ScrHeight - 165, RGBA(1, 1, 0, 1), "screeninfo"
    End Select
    
    'Write tank text
    Select Case TeamChosen
        Case 0 'red
            Scr.DrawText "QUICK SELECT NEXT:", ScrWidth - 150, ScrHeight - 65, RGBA(1, 0, 0, 1), "screeninfo"
        Case 1 'blue note : blue is (0,0.3,1)... more clear
            Scr.DrawText "QUICK SELECT NEXT:", ScrWidth - 150, ScrHeight - 65, RGBA(0, 0.3, 1, 1), "screeninfo"
        Case 2 'green
            Scr.DrawText "QUICK SELECT NEXT:", ScrWidth - 150, ScrHeight - 65, RGBA(0, 1, 0, 1), "screeninfo"
        Case 3 'yellow
            Scr.DrawText "QUICK SELECT NEXT:", ScrWidth - 150, ScrHeight - 65, RGBA(1, 1, 0, 1), "screeninfo"
    End Select
    
    
    'Draw images
    MenuImage(1) = Scr.RollOver(GetTex("mammoth1"), GetTex("mammoth2"), ScrWidth - 150, ScrHeight - 50, ScrWidth - 76, ScrHeight - 1, False)
    MenuImage(2) = Scr.RollOver(GetTex("mosquito1"), GetTex("mosquito2"), ScrWidth - 75, ScrHeight - 50, ScrWidth - 1, ScrHeight - 1, False)
    MenuImage(3) = Scr.RollOver(GetTex("silo1"), GetTex("silo2"), ScrWidth - 150, ScrHeight - 150, ScrWidth - 76, ScrHeight - 101, False)
    
    'Set no texture by default
    RollOnTexture = 0
    
    'What image is selected?
    Dim i As Integer
    For i = 1 To 3
        If MenuImage(i) = True Then
            RollOnTexture = i
        End If
    Next i
    
    '====================
    'Show the game's name
    '====================
    Scr.DrawText "HOVERTANKS " & GameVersion, 5, ScrHeight - 20, RGBA(1, 1, 1, 1), "screeninfo"
    
End Sub

Private Sub Save_Cam_Pos(WhichCam)
    
    '====================
    'Save camera position
    '====================
    CamSavePosX(WhichCam) = CamPosX
    CamSavePosY(WhichCam) = CamPosY
    CamSavePosZ(WhichCam) = CamPosZ
    CamSaveLookX(WhichCam) = CamLookX
    CamSaveLookY(WhichCam) = CamLookY
    CamSaveLookZ(WhichCam) = CamLookZ
    
    '=========================================
    'Tell the player we have saved the cam pos
    '=========================================
    Info2Player(0) = "Camera" & WhichCam + 1 & " position saved!"
    
End Sub

Private Sub Call_Cam_Pos(WhichCam)
    
    '====================
    'Call camera position
    '====================
    CamPosX = CamSavePosX(WhichCam)
    CamPosY = CamSavePosY(WhichCam)
    CamPosZ = CamSavePosZ(WhichCam)
    CamLookX = CamSaveLookX(WhichCam)
    CamLookY = CamSaveLookY(WhichCam)
    CamLookZ = CamSaveLookZ(WhichCam)
    
    '=========================================
    'Tell the player we have saved the cam pos
    '=========================================
    Info2Player(0) = "Camera" & WhichCam + 1 & " position called!"
    
    '===================
    'Stop moving the cam
    '===================
    Stop_Cam_Smooth
    
End Sub

Private Sub Stop_Cam_Smooth()

    '==================================================
    'This is called when the camera is in movement
    'and when we call a saved camera position or a tank
    '==================================================
    CamSmoothX = 0
    CamSmoothY = 0
    CamSmoothZ = 0
    
End Sub

